import { PnpmOptions, Dependencies } from '../types';
import { InstalledPackage } from '../install/installMultiple';
import { Shrinkwrap } from 'pnpm-shrinkwrap';
import { Package } from '../types';
import { DirectoryResolution } from '../resolve';
export declare type InstalledPackages = {
    [name: string]: InstalledPackage;
};
export declare type TreeNode = {
    nodeId: string;
    children: string[];
    pkg: InstalledPackage;
    depth: number;
    installable: boolean;
};
export declare type TreeNodeMap = {
    [nodeId: string]: TreeNode;
};
export declare type PackageContentInfo = {
    isNew: boolean;
    index: {};
};
export declare type InstallContext = {
    installs: InstalledPackages;
    localPackages: {
        optional: boolean;
        dev: boolean;
        resolution: DirectoryResolution;
        id: string;
        version: string;
        name: string;
        specRaw: string;
    }[];
    childrenIdsByParentId: {
        [parentId: string]: string[];
    };
    nodesToBuild: {
        nodeId: string;
        pkg: InstalledPackage;
        depth: number;
        installable: boolean;
    }[];
    shrinkwrap: Shrinkwrap;
    fetchingLocker: {
        [pkgId: string]: {
            fetchingFiles: Promise<PackageContentInfo>;
            fetchingPkg: Promise<Package>;
            calculatingIntegrity: Promise<void>;
        };
    };
    skipped: Set<string>;
    tree: {
        [nodeId: string]: TreeNode;
    };
};
export declare function install(maybeOpts?: PnpmOptions): Promise<void>;
/**
 * Perform installation.
 *
 * @example
 *     install({'lodash': '1.0.0', 'foo': '^2.1.0' }, { silent: true })
 */
export declare function installPkgs(fuzzyDeps: string[] | Dependencies, maybeOpts?: PnpmOptions): Promise<void>;
