"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const storeStatus_1 = require("../api/storeStatus");
const errorTypes_1 = require("../errorTypes");
const pnpm_logger_1 = require("pnpm-logger");
class StoreStatusError extends errorTypes_1.PnpmError {
    constructor(modified) {
        super('MODIFIED_DEPENDENCY', '');
        this.modified = modified;
    }
}
function default_1(input, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        if (input[0] !== 'status') {
            throw new Error('Unknown command');
        }
        const modifiedPkgs = yield storeStatus_1.default(opts);
        if (!modifiedPkgs || !modifiedPkgs.length) {
            pnpm_logger_1.default.info('Packages in the store are untouched');
            return;
        }
        throw new StoreStatusError(modifiedPkgs);
    });
}
exports.default = default_1;
//# sourceMappingURL=store.js.map