"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pLimit = require("p-limit");
/**
 * Save promises for later
 */
function memoize(concurrency) {
    const locks = {};
    const limit = concurrency && pLimit(concurrency);
    return function (key, fn) {
        if (locks[key])
            return locks[key];
        locks[key] = limit && limit(fn) || fn();
        return locks[key];
    };
}
exports.default = memoize;
//# sourceMappingURL=memoize.js.map