"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(pkgName, pkgVersion, opts) {
    const registry = normalizeRegistry(opts && opts.registry || 'http://registry.npmjs.org/');
    const scopelessName = getScopelessName(pkgName);
    return `${registry}${pkgName}/-/${scopelessName}-${pkgVersion}.tgz`;
}
exports.default = default_1;
function normalizeRegistry(registry) {
    if (registry[registry.length - 1] === '/')
        return registry;
    return `${registry}/`;
}
function getScopelessName(name) {
    if (name[0] !== '@') {
        return name;
    }
    return name.split('/')[1];
}
//# sourceMappingURL=index.js.map