declare var _default: any;
export default _default;
export declare type LifecycleMessage = {
    pkgId: string;
    line: string;
};
export declare type ProgressMessage = {
    pkgId: string;
    status: 'fetched' | 'installed' | 'dependencies_installed';
} | {
    pkgId: string;
    pkg: LoggedPkg;
    status: 'resolved';
} | {
    pkg: LoggedPkg;
    status: 'resolving' | 'error' | 'installing';
} | {
    pkgId: string;
    status: 'fetching';
    progress?: {
        done: number;
        total: number;
    };
} | {
    status: 'downloaded_manifest';
    pkgId: string;
    pkgVersion: string;
};
export declare type InstallCheckMessage = {
    code: string;
    pkgId: string;
};
export declare type Log = {
    name: string;
    level: 'debug' | 'info' | 'warn' | 'error';
};
export declare type ProgressLog = Log & ProgressMessage;
export declare type LifecycleLog = Log & LifecycleMessage;
export declare type InstallCheckLog = Log & InstallCheckMessage;
export declare type LoggedPkg = {
    rawSpec: string;
    name: string;
    dependentId?: string;
};
