import { PackageSpec, ResolveOptions, ResolveResult } from '..';
import { PackageMeta } from './loadPackageMeta';
export { PackageMeta };
/**
 * Resolves a package in the NPM registry. Done as part of `install()`.
 *
 * @example
 *     var npa = require('npm-package-arg')
 *     resolve(npa('rimraf@2'))
 *       .then((res) => {
 *         res.id == 'rimraf@2.5.1'
 *         res.dist == {
 *           shasum: '0a1b2c...'
 *           tarball: 'http://...'
 *         }
 *       })
 */
export default function resolveNpm(spec: PackageSpec, opts: ResolveOptions): Promise<ResolveResult>;
