"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const loadJsonFile = require("load-json-file");
const writePkg = require("write-pkg");
const getSaveType_1 = require("./getSaveType");
function save(pkgJsonPath, packageSpecs, saveType) {
    return __awaiter(this, void 0, void 0, function* () {
        // Read the latest version of package.json to avoid accidental overwriting
        const packageJson = yield loadJsonFile(pkgJsonPath);
        if (saveType) {
            packageJson[saveType] = packageJson[saveType] || {};
            packageSpecs.forEach(dependency => {
                packageJson[saveType][dependency.name] = dependency.saveSpec;
                getSaveType_1.dependenciesTypes.filter(deptype => deptype !== saveType).forEach(deptype => {
                    if (packageJson[deptype]) {
                        delete packageJson[deptype][dependency.name];
                    }
                });
            });
        }
        else {
            packageSpecs.forEach(dependency => {
                const usedDepType = guessDependencyType(dependency.name, packageJson) || 'dependencies';
                packageJson[usedDepType] = packageJson[usedDepType] || {};
                packageJson[usedDepType][dependency.name] = dependency.saveSpec;
            });
        }
        yield writePkg(pkgJsonPath, packageJson);
        return packageJson;
    });
}
exports.default = save;
function guessDependencyType(depName, pkg) {
    return getSaveType_1.dependenciesTypes
        .find(deptype => Boolean(pkg[deptype] && pkg[deptype][depName]));
}
//# sourceMappingURL=save.js.map